#include <stdio.h>			// Other necessary program related includes.
#include <stdlib.h>
#include <math.h>
#include <GLUT/glut.h>

void MyDrawSphere(double, int, int);

void MyglutSolidSphere(double r, int la, int lo){ MyDrawSphere(r, la, lo); }

void MyDrawSphere(double r, int lats, int longs) {
    int i, j;
    for(i = 0; i <= (lats); i++) {
        
		  //latitude of lower corner of strip, [0 .. PI]
		  double lat0 = M_PI * ((double) (i - 1) / lats);
		  double z0  = r * cos(lat0);
        double zr0 = r * sin(lat0);
 
		  //upper corner of strip, [0 .. PI]
        double lat1 = M_PI * ((double) i / lats);
		  double z1 = r * cos(lat1);
        double zr1 = r * sin(lat1);
 

        glBegin(GL_QUAD_STRIP);

        for(j = 0; j <= (longs); j++) {
        	  
			  //longitute of current corner, [0 .. 2PI]
  		  double lng = 2 * M_PI * (double) (j - 1) / longs;
            double x = sin(lng);
            double y = cos(lng);

			  //set the color of this vertex
			  //glColor3f( sin(((1.0/lats)*i)*M_PI), sin(((1.0/longs)*j)*M_PI), (1.0 / longs / lats) * j * i);
			
            glNormal3f(x * zr0, y * zr0, z0);
            glVertex3f(x * zr0, y * zr0, z0);
            
			  glNormal3f(x * zr1, y * zr1, z1);
            glVertex3f(x * zr1, y * zr1, z1);
        }
        glEnd();
    }
}


  //topR should always be smaller!
void MyDrawCylinder(float baseR, float topR, float len, int slices, int stacks){

	float r_dec = (baseR - topR) / stacks;
	float r = baseR;

	for(int i=0; i<stacks; i++) {

		 //height of lower corner of strip, [0 .. len]
		  double h0 = len * ((double) (i - 1) / stacks);
		 //radius of lower corner of strip
		  double r0 = r;

		  //height upper corner of strip, [0 .. len]
          double h1 = len * ((double) i / stacks);
		  double r1 = (r - r_dec);


		glBegin(GL_QUAD_STRIP);

          for(int j = 0; j <= (slices); j++) {

			  //theta of current corner, [0 .. 2PI]
    		  double theta = 2 * M_PI * (double) (j - 1) / slices;
              double x = cos(theta);
              double y = sin(theta);


              //lower vertex
			  glNormal3f(x * r0, y * r0, h0);
              glVertex3f(x * r0, y * r0, h0);

			  //upper vertex
			  glNormal3f(x * r1, y * r1, h1);
              glVertex3f(x * r1, y * r1, h1);
          }
          glEnd();	

		  r -= r_dec;

	}

}