//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Cam_H
#define SS_Cam_H


//==================================================================
//  Camera Class Definition
//==================================================================

class Camera {
	
	protected:

		//center of projection, eye position
		Vector3 e;
		
		//look at point d
		Vector3 d;
		
		//up vector
		Vector3 up;


		//cam matrix
		Matrix4 cam_mat;
		
		
	public:
	
		//getters
		
		//----------------------------------------------------------
		// Empty constr, sets to 0
		Camera() { 
			recalcCamMat();
		}

		// 3D Matrix4
		Camera( Vector3 ev, Vector3 dv, Vector3 upv ) {
			e = ev;
			d = dv;
			up = upv;
			recalcCamMat();
		}

		// Destructor
		~Camera() {};

		//----------------------------------------------------------
		// get/set
		Vector3 get_d(){ return d; }
		void 	set_d(Vector3 dv){ d = dv; recalcCamMat(); }

		Vector3 get_e(){ return e; }
		void 	set_e(Vector3 ev){ e = ev; recalcCamMat(); }

		Vector3 get_up(){ return up; }
		void 	set_up(Vector3 u){ up = u; recalcCamMat(); }
		
		void	recalcCamMat();
		
		Matrix4 getCamMatrix(){ return cam_mat; }
		



		//----------------------------------------------------------
		// Special Operations
		friend std::ostream &operator<<(std::ostream &out, Camera &cam);





};


#endif SS_Cam_H
