#include "common.h" 
#include "house3.h" 

#define MY_CAM 0
#define IMAGE_TEST 2
#define TRACKBALL 1
#define STEP 5
#define GAIN 1

   
	//the coords of the trackball camera
  	//longs, azimuth
	double user_phi = 0;
	//lats, elevation, inclenation
	double user_theta  = 0;
  	double user_r = 40;

	//lats = theta
	//longs = phi
   
  void drawHouse() {
	int i, j, idx,vxn;

	//draw all the triangs, there should be 20
	for (i = 0; i < 20; i++){
		idx = (i*3);
		
		glBegin(GL_TRIANGLES);
		
		cout << "Drawing triangle #" << i << " with idx: " << idx << endl;

		//now draw each of the 3 vertices
		for (j = 0; j < 3; j++){
			vxn = (indices[idx+j]) * 3;
			glColor3f(colors[vxn], colors[vxn+1], colors[vxn+2]);
			cout << "Drawing vertex #" << (idx+j) << ", vxn: " << vxn << "@[" << vertices[vxn] << "," << vertices[vxn+1] << "," << vertices[vxn+2] << "]" << " and color: (" << colors[vxn] << "," << colors[vxn+1] << "," << colors[vxn+2] << ")" << endl;
			//draw each vertex
	      	glVertex3f(vertices[vxn], vertices[vxn+1], vertices[vxn+2]);
		}      
		glEnd();

	}

	
	return;
	/*
		//draw the quad array first
		// activate and specify pointer to vertex array
		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);
	    
		glVertexPointer(3, GL_FLOAT, 0, house_quads);
		glColorPointer(3, GL_FLOAT, 0, house_colors_quads);
	    
		// draw house
		glDrawArrays(GL_QUADS, 0, house_nQuads);

		// deactivate vertex arrays after drawing
	    glDisableClientState(GL_COLOR_ARRAY);
		glDisableClientState(GL_VERTEX_ARRAY);

		//then draw the triad array
		// activate and specify pointer to vertex array
		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);
	    
		glVertexPointer(3, GL_FLOAT, 0, house_triads);
		glColorPointer(3, GL_FLOAT, 0, house_colors_triads);
	    
		// draw house
		glDrawArrays(GL_TRIANGLES, 0, house_nTriads);

		// deactivate vertex arrays after drawing
	    glDisableClientState(GL_COLOR_ARRAY);
		glDisableClientState(GL_VERTEX_ARRAY);
		*/
	
  }
  


//use mouse as trackball
void location_trackBall() {
      
		double x = user_r * sin(deg2rad(user_theta)) * cos(deg2rad(user_phi));     // eye x-, y-, and z-coordinates
      	double y = user_r * sin(deg2rad(user_theta)) * sin(deg2rad(user_phi));
      	double z = user_r * cos(deg2rad(user_theta));
      	
		//set projection matrix
		Frustrum f;
	
				//fovy, aspect, zNear, zFar
		f.generate(60.0, 1.0, 1.0, 100.0);
		f.set_OGL();
		
		Matrix4 t;
		t.make_ident();
		
		Vector3 ev(x,y,z), dv(0,0,0), uv(0,1,0);
		Camera cam(ev, dv, uv);

		glMatrixMode(GL_MODELVIEW); 
		
		//try the inverse
		Matrix4 cammat = cam.getCamMatrix().inverse();
		//cout << "My MODELVIEW is: " << cammat << endl;


		glLoadIdentity(); 
		//now set cam matrix
		glLoadMatrixd(cammat.GL_matrix());
		
      
  }


//OpenGL's coode
void computeLocation1() {

	glMatrixMode(GL_PROJECTION); 
	glLoadIdentity(); 
				//fovy, aspect, zNear, zFar
	gluPerspective(60.0, 1.0, 1.0, 100.0); 

	double dvProjMatrix[ 16 ];
	double dvViewMatrix[ 16 ];
	int dvViewPort[ 4 ];
	double screen_x, screen_y, screen_z;
	
	glGetDoublev( GL_PROJECTION_MATRIX, dvProjMatrix );
	glGetIntegerv( GL_VIEWPORT, dvViewPort );
	//now make a mat our of it
	Matrix4 tproj(dvProjMatrix);
	cout << "OpenGL PROJECTION is: " << tproj << endl;

	glMatrixMode(GL_MODELVIEW); 
	glLoadIdentity(); 
	if (IMAGE_TEST == 1)
		gluLookAt(	0.0, 0.0, 40.0, 		//eye position
					0.0, 0.0, 0.0, 		//lookat
					0.0, 1.0, 0.0);		//up vector
   	else
		gluLookAt(	-10.0, 40.0, 40.0, 		//eye position
					-5.0, 0.0, 0.0, 		//lookat
					0.0, 1.0, 0.0);		//up vector
		
	glGetDoublev( GL_MODELVIEW_MATRIX, dvViewMatrix );
	//now make a mat out of it
	Matrix4 tmat(dvViewMatrix);
	cout << "OpenGL MODELVIEW is: " << tmat << endl;
	
	//take a sample point: -4,-4,4 and project to screen coords
	
	gluProject(-4, -4, 4,
	    dvViewMatrix, dvProjMatrix, dvViewPort, 
	    &screen_x, &screen_y, &screen_z);
	
	cout << "Screen-coords of -4,-4,4: [" << screen_x << "," << screen_y  << "," << screen_z << "]" << endl;


}

//use our own code
void computeLocation3() {

	//set projection matrix
	Frustrum f;
	
			//fovy, aspect, zNear, zFar
	f.generate(60.0, 1.0, 1.0, 100.0);
	f.set_OGL();
	
	cout << "My PROJECTION is: " << f << endl;
	
	
	//now set cam matrix
	
	Matrix4 t;
	t.make_ident();
	double e[3] = {0.0, 0.0, 40.0}, d[3] = {0.0, 0.0, 0.0}, u[3] = {0.0, 1.0, 0.0};
	
	if (IMAGE_TEST == 1){
		//e = ;
		//d = 
		//u = ;
	}else{
		e[0] = -10.0;
		e[1] = 40.0;
		e[2] = 40.0;
		
		d[0] = -5.0;
		d[1] = 0.0;
		d[2] = 0.0;
		
		u[0] = 0.0;
		u[1] = 1.0;
		d[2] = 0.0;
	}
		

	Vector3 ev(e), dv(d), uv(u);
	Camera cam(ev, dv, uv);
	
	glMatrixMode(GL_MODELVIEW); 
	//asume modeling matrix as ident()
	//cammat *= t;
	Matrix4 cmmat = cam.getCamMatrix();
	cout << "My cammat is: " << cmmat << endl;
	
	//try the inverse
	Matrix4 cammat = cam.getCamMatrix().inverse();
	//Matrix4 cammat = cam.getCamMatrix();
	cout << "My MODELVIEW is: " << cammat << endl;

	
	glLoadIdentity(); 
	//now set cam matrix
	glLoadMatrixd(cammat.GL_matrix());
	
	
}


void computeLocation() {
	
	if(TRACKBALL){
		location_trackBall();
		return;
	}	
	
	if (MY_CAM)
	  	computeLocation3();
      else
		computeLocation1();
	
	
}


const GLfloat DefaultAxisLength=4;

void drawReferenceAxis()
						// Draw the reference axis
{
	
	 glPushAttrib(GL_ALL_ATTRIB_BITS);
						// Pushes attributes like current color to attribute stack.
	 glBegin(GL_LINES);
						// X axis red
      glColor3f(1, 0, 0);
      glVertex3f(0, 0, 0);
      glVertex3f(DefaultAxisLength, 0, 0);
						// Y axis green
      glColor3f(0, 1, 0);
      glVertex3f(0, 0, 0);
      glVertex3f(0, DefaultAxisLength, 0);
						// Z axis blue
      glColor3f(0, 0, 1);
      glVertex3f(0, 0, 0);
      glVertex3f(0, 0, DefaultAxisLength);
	  glEnd();
	  glPopAttrib();
						// // Pops attributes like current color from the attribute stack and sets as current.
	
}

  // Initializes information for drawing within OpenGL.
  void init() {
      GLfloat sun_direction[] = { 0.0, 2.0, -1.0, 1.0 };
      GLfloat sun_intensity[] = { 0.7, 0.7, 0.7, 1.0 };
      GLfloat ambient_intensity[] = { 0.3, 0.3, 0.3, 1.0 };
   
      glClearColor(0.0, 0.0, 0.0, 0.0);   // Set window color to black.
      computeLocation();
      
      glEnable(GL_DEPTH_TEST);            // Draw only closest surfaces
   
      glEnable(GL_LIGHTING);              // Set up ambient light.
      glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient_intensity);
   
      glEnable(GL_LIGHT0);                // Set up sunlight.
      glLightfv(GL_LIGHT0, GL_POSITION, sun_direction);
      glLightfv(GL_LIGHT0, GL_DIFFUSE, sun_intensity);
   
      glEnable(GL_COLOR_MATERIAL);        // Configure glColor().
      glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
  }
   
  // Draws the current image.
  void draw() {
      	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); // Clear window.
      	
		//set global color to white
	  	//glColor3f(1.0, 0.0, 0.0);
      	glShadeModel(GL_SMOOTH);
      
		drawReferenceAxis();
		drawHouse();
      	glutSwapBuffers();
  }
   
  // Arranges that the window will be redrawn roughly every 1 s.
  void idle() {
      static int lastTime = 0;                // time of last redraw
      int time = glutGet(GLUT_ELAPSED_TIME);  // current time
   
      if(lastTime == 0 || time >= lastTime + 1000) {
          lastTime = time;
          //glutPostRedisplay();
      }
  }
   

int old_x = 0, old_y = 0;

void MouseMotionFunc(int x, int y){
	
	//cout << "Mouse moved with x:" << x << ", y:" << y <<endl;
	int delta_x =  x - old_x;
	//int delta_x =  old_x - x;
	int delta_y =  y - old_y;
	
	//cout << "Mouse moved with deltax:" << delta_x << ", deltay:" << delta_y <<endl;
	//set new theta, and phi
	
	user_phi 	+= 	GAIN * delta_y;
	user_theta 	+= 	GAIN * delta_x;
	
	computeLocation();
    glutPostRedisplay();
    
	old_x = x; old_y = y;
}


  // When window becomes visible, we want the window to
  // continuously repaint itself.
  void visible(int vis) {
      glutIdleFunc(vis == GLUT_VISIBLE ? idle : NULL);
  }
   

  // Called when a "special" key is pressed
  void special(int k, int x, int y) {
      switch(k) {
	      case GLUT_KEY_UP:    user_phi += STEP; break;
	      case GLUT_KEY_DOWN:  user_phi -= STEP; break;
	      case GLUT_KEY_LEFT:  user_theta  += STEP; break;
	      case GLUT_KEY_RIGHT: user_theta  -= STEP; break;
	  }
      computeLocation();
      glutPostRedisplay();
  }
 
  
void keyboardCallbackProc(unsigned char key, int x, int y)
						// This is the callback procedure for capturing OpenGL Keyboard events.
{
	GLfloat temp;


	switch(key)
	{
	      case 'f':  			user_r  += STEP; break;
	      case 'g': 			user_r  -= STEP; break;
	}
    computeLocation();
    glutPostRedisplay();

}

  int main(int argc, char **argv) {
      glutInit(&argc, argv);
      glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGB);
      glutInitWindowPosition(50, 100);    // Set up display window.
      glutInitWindowSize(512, 512);
      glutCreateWindow("House");
   
      init();
      glutDisplayFunc(draw);
      glutVisibilityFunc(visible);
      glutKeyboardFunc(keyboardCallbackProc);
	  glutSpecialFunc(special);
	  glutMotionFunc(MouseMotionFunc);
	
      glutMainLoop();
      return 0;
  }
