//==================================================================
//==================================================================

#include "common.h"

using namespace std;

//------------------------------------------------------------------
// vtest - test Vector3 class methods
//------------------------------------------------------------------

	
void test_cam(){
	cout << "----------------------------Testing Camera -----------------------" << endl;	
	double	a, c[3];
	bool b;
	Vector3 v3e(2,0,-2);
	Vector3 v3d(1,1,1);
	Vector3 v3u(0.2, 0.2, 0.0);
	Camera	u, v(v3e, v3d, v3u);


	// output preset coords of v and w
	cout << "Initial cam = " << u << endl;
	cout << "Initial v = " << v << endl;
	cout << endl;


	//test getters setters
	Vector3 t, v3(4,5,6);
	u.set_d(v3);
	cout << "Initial v3 = " << v3 << endl;
	cout << "u.set_d(v3) = " << u << endl;
	t = u.get_d();		cout << "u.get_d() = " << t << endl;


}


//------------------------------------------------------------------
// vtest - test Vector3 class methods
//------------------------------------------------------------------

	/*
void test_v4(){
	cout << "----------------------------Testing Vector4 -----------------------" << endl;	
		
	double	a, c[3];
	Vector4	u, v(1), w(0,1), xz(0,1);
	Vector4 test1(2,3,4,5), test2(4,5,6,7), test3(10,11,12,13);
	//Vector4	vx[3];


	// output preset coords of v and w
	cout << "Initial v = " << v << endl;
	cout << "Initial w = " << w << endl;
	cout << "Initial x = " << xz << endl;
	cout << "Initial t1 = " << test1 << endl;
	cout << "Initial t2 = " << test2 << endl;
	cout << "Initial t3 = " << test3 << endl;
	cout << endl;


	// test operators
	u = v * 2;		cout << "2*v = " << u << endl;
	xz *= 2;			cout << "x *= 2 = " << xz << endl;
	u = w * 2;			cout << "w * 2 = " << u << endl;
	u = v + w;		cout << "v + w = " << u << endl;
	u = (v + w) * 2;	cout << "(v + w) * 2 = " << u << endl;
	u = v / 2;		cout << "v/2 = " << u << endl;
	u = v - w;		cout << "v - w = " << u << endl;
	u = (v - w) * 2;	cout << "(v - w)*2 = " << u << endl;
	cout << endl;


	a = v.len2();		cout << "v.len2() = " << a << endl;
	a = v.len();		cout << "v.len()  = " << a << endl;
	a = test1.len();		cout << "t1.len()  = " << a << endl;
	a = test1.len2();		cout << "t1.len2()  = " << a << endl;
	v.normalize();		cout << "v.normalize() = " << v << endl;
	w.normalize();		cout << "w.normalize() = " << w << endl;
	test1.normalize();		cout << "t1.normalize() = " << test1 << endl;
	test2.normalize();		cout << "t2.normalize() = " << test2 << endl;
	test3.dehomogenize();		cout << "t3.dehomogen() = " << test3 << endl;
	cout << endl;


}


void test_mat(){
	cout << "----------------------------Testing Matrxi4 -----------------------" << endl;	
	
	Matrix4	u, v(1), w(1), xz(5);
	double dub[4][4] = {{1,2,3,4},{2,3,4,5},{4,5,6,7},{6,7,8,9}};
	double *flat;
	
	Matrix4 test1(dub);
	Vector4 vec4_1(2,3,4,5), v4;
	Vector3 vec3_1(2,3,4), v3;
	

	// output preset coords of v and w
	cout << "Initial v = " << v << endl;
	cout << "Initial w = " << w << endl;
	cout << "Initial x = " << xz << endl;
	cout << "Initial t1 = " << test1 << endl;
	cout << endl;
	
	//test ops
	//mat x mat
	u = v * w;			cout << "v * w = " << u << endl;
	u = v * test1;		cout << "v * t1 = " << u << endl;

	u = test1.transpose();		cout << "t1.transpose() = " << u << endl;

	flat = test1.flatten();		cout << "t1.flatten()[0] = " << flat[0] << endl; cout << "t1.flatten()[4] = " << flat[4] << endl; cout << "t1.flatten()[7] = " << flat[7] << endl;
	flat = test1.GL_matrix();		cout << "t1.GL_matrix()[0] = " << flat[0] << endl; cout << "t1.GL_matrix()[4] = " << flat[4] << endl; cout << "t1.GL_matrix()[7] = " << flat[7] << endl;

	//mat x vec
	v4 = v * vec4_1;			cout << "v * vec4 = " << v4 << endl;
	v3 = v * vec3_1;			cout << "v * vec3 = " << v3 << endl;
	xz.make_rotX(M_PI/2);			cout << "rotX(90) = " << xz << endl;
	xz.make_rotY(M_PI/2);			cout << "rotY(90) = " << xz << endl;
	xz.make_rotZ(M_PI/2);			cout << "rotZ(90) = " << xz << endl;
	xz.make_rot(M_PI/2, M_PI/2, M_PI/2); cout << "rot(90, 90, 90) = " << xz << endl;
	xz.make_rot(M_PI/2, M_PI, M_PI/2); cout << "rot(90, 180, 90) = " << xz << endl;

	xz.make_rot(vec3_1, M_PI); cout << "rot([2,3,4], 90) = " << xz << endl;


	xz.make_scaling(2,2,2); cout << "scaling(2,2,2) = " << xz << endl;
	xz.make_translation(3,3,3); cout << "trans(3,3,3) = " << xz << endl;
	
	cout << endl;
	
	
	
}


int main()
{
	test_cam();
	return 0;
}
*/
