//==================================================================
//==================================================================

#include "common.h"
using namespace std;

//==================================================================
// Camera Class Methods
//==================================================================



void	Camera::recalcCamMat(){
	//recalculate the internal camera Matrix
	Vector3 t,s,u,v;
	
	//forward vector
	t = e - d;
	//cout << "(t="<< e << " - " << d << ") = " << t << endl;
	//cout << "|t| = " << t.len() << endl;
	//Vector3 z_c = t / ((t.len() > 0) ? t.len() : 1);
	
	Vector3 z_c = e - d; //e - d;
	z_c.normalize();
	//cout << "z_c = " << z_c << endl;
	
	//left vector
	Vector3 x_c = up ^ z_c;
	x_c.normalize();
	//cout << "s= ("<< up << " X " << z_c << ")=" << s << endl;
	//Vector3 x_c = s / ((s.len() > 0) ? s.len() : 1);
	//cout << "x_c= " << x_c << endl;
	
	//up vector
	Vector3 y_c = z_c ^ x_c;
	y_c.normalize();
	
	//promote all to Vec4's
	Vector4 v4_x(x_c[0], x_c[1], x_c[2], 0);
	Vector4 v4_y(y_c[0], y_c[1], y_c[2], 0);
	Vector4 v4_z(z_c[0], z_c[1], z_c[2], 0);
	Vector4 v4_e(e[0], e[1], e[2], 1);
	
	//and make new matrix from them
	Vector4 vec4_a[4] = {v4_x, v4_y, v4_z, v4_e};
	cam_mat = Matrix4(vec4_a);
	
	
}

//fast-invert the cam matrix by multiplying transposed u,v,w mat with a -e Mat4
//that is transposed rotation matrix R^T X T(-t)
Matrix4 Camera::invertedCamMatrix(){
	
	
	Matrix4 eye_neg;
	eye_neg.make_ident();
	eye_neg.set(0,3,-cam_mat.get(0,3));
	eye_neg.set(1,3,-cam_mat.get(1,3));
	eye_neg.set(2,3,-cam_mat.get(2,3));
	
	
	Matrix4 transposed = cam_mat.transpose();
	//set last row to 0,0,0,3
	transposed.set(3,0,0);
	transposed.set(3,1,0);
	transposed.set(3,2,0);
	
	
	//now multiply
	return (transposed * eye_neg);
	
	
}


//------------------------------------------------------------------
//  Special
//------------------------------------------------------------------

// Write output Matrix
std::ostream& operator<<(std::ostream &out, Camera &cam) {
	out << "Cam(e:";

	cout << cam.e << ",d:" << cam.d << ",u:" << cam.up << ",m:" << cam.cam_mat;
	
	out << ")";
	return out;
}
