//------------------------------------------------------------------
//------------------------------------------------------------------

#ifndef SS_Common_H
#define SS_Common_H

#ifdef _WIN32
  	#include <windows.h>
	#include <GL/glut.h>
	#include <GL/gl.h>
#else
	#include <GLUT/glut.h>
#endif

#include <stdio.h>
#include <math.h>
#include <iostream>
#include <ostream>

inline float deg2rad(float degree){return degree/360.0*2*M_PI;}

//HW Project3
#define PART_1 	1
#define PART_2A 0

//if this is defined the house geometry is switched to the more colorful version
//#define COLORFUL_HOUSE


#define DIM3 3
#define DIM4 4
#define MATRIX_DIM 4

#include "vector4.h"
#include "vector3.h"
#include "matrix4.h"
#include "camera.h"
#include "frustrum.h"
#include "viewport.h"


struct Color    // generic color
{
  float r,g,b;
};

struct Point2D    // generic point in 2d
{
  int x,y;
  double z,w;
};

struct Vertex3D    // generic 3D vertex
{
  Color color;
  Vector3 coords;
};

struct Vertex2D    // generic 2D vertex, has a 2DPoint instead of Vector3
{
  Color color;
  Point2D coords;
};




//forward function definitions
void drawPoint(int, int, double, float, float, float);
void drawPoint(int, int, double, Color);
Vertex2D rasterizeVertex(Vertex3D);
void rasterizeTriangle(Vertex3D vs[3]);
int f_ab(Point2D, Point2D, Point2D);
Color interpolate_color_lin(double, double, double, Color, Color, Color);
Color interpolate_color_hyperb(double, double, double, Vertex2D, Vertex2D, Vertex2D);

//the Model Matrix M
extern Matrix4 model;

extern Camera cam;
extern Frustrum frust;

//the viewport
extern Viewport View_Port;




#endif SS_Common_H
