//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Frust_H
#define SS_Frust_H


//==================================================================
//  Frustrum Class Definition
//==================================================================

class Frustrum {
	
	protected:


		//Projection matrix
		Matrix4 Ppersp;
		
		double fov, aspect, near, far;
		
	public:
	
		// Empty constr, sets to 0
		Frustrum() { 
			regen();
		}

		// 
		Frustrum( double fo, double as, double ne, double fa ) {
			fov = fo;
			aspect = as;
			near = ne;
			far = fa;
			regen();
		}

		// Destructor
		~Frustrum() {};
		

		void set_aspect(double asp){ aspect = asp; regen(); }
		//generates the projection matrix from near, far, aspect and fov
		
		void set(double, double, double, double);
		void regen();
		void set_OGL(){
			glMatrixMode(GL_PROJECTION);
			glLoadMatrixd(Ppersp.GL_matrix());
		}
		
		Matrix4 getProjectionMat(){ return Ppersp; }



		//----------------------------------------------------------
		// Special Operations
		friend std::ostream &operator<<(std::ostream &out, Frustrum &fru);





};


#endif SS_Frust_H
