//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Viewport_H
#define SS_Viewport_H


//==================================================================
//  Viewport Class Definition
//==================================================================

class Viewport {
	
	protected:


		//Viewport matrix
		Matrix4 viewport_mat;
		
		int width, height;
		
	public:
	
		//getters
		
		//----------------------------------------------------------
		// Empty constr, sets to 0
		Viewport() { 
			recalcVPMat();
		}

		// 3D Matrix4
		Viewport( int w, int h ) {
			width = w;
			height = h;
			recalcVPMat();
		}

		// Destructor
		~Viewport() {};

		//----------------------------------------------------------
		// get/set
		void 	set_dim(int w, int h){ width = w; height = h; recalcVPMat(); }
		
		int 	get_width(){ return width; }
		void 	set_width(int w){ width = w; recalcVPMat(); }

		int 	get_height(){ return height; }
		void 	set_height(int h){ height = h; recalcVPMat(); }

		
		void	recalcVPMat();
		
		Matrix4 getVPMatrix(){ return viewport_mat; }
		



		//----------------------------------------------------------
		// Special Operations
		friend std::ostream &operator<<(std::ostream &out, Viewport &vp);





};


#endif SS_Viewport_H
