//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Light_H
#define SS_Light_H


//==================================================================
//  Light Class Definition
//==================================================================

class Light {
	
protected:					//		
	
	int		LightIndex;
	int		OGL_light_index;
	
public:
	//----------------------------------------------------------
	//  Constructor that specifies the light number
	Light(int idx) { 
		
		OGL_light_index = GL_LIGHT0 + idx;
		LightIndex = idx;
		
	}


	// Destructor
	~Light() {};
	
	
	//----------------------------------------------------------
	//some functions to set various parameters
	
	void enable(){ 
		//cout << "Enabling " << OGL_light_index << endl;
		glEnable(OGL_light_index); 
	}
	void disable(){ 
		//cout << "Disabling " << OGL_light_index << endl;
		glDisable(OGL_light_index); 
	}
	
	void setPositional(float, float, float);
	void setDirectional(float, float, float);
	
	void setAmbient(float, float, float, float);
	void setDiffuse(float, float, float, float);
	void setSpecular(float, float, float, float);
	
	
	//Spotlight
	//x,y,z, exponent, cutoff
	void setSpot(float, float, float, float, float);
	//constant, lin, quadr.
	void setAttenuation(float, float, float);
	
	
	//----------------------------------------------------------
	// Special Operations
	friend std::ostream &operator<<(std::ostream &out, Light &mat);
	
	
};

#endif SS_Light_H