//------------------------------------------------------------------
//------------------------------------------------------------------

#ifndef SS_Common_H
#define SS_Common_H

#ifdef _WIN32
  	#include <windows.h>
	#include <GL/glut.h>
	#include <GL/gl.h>
#else
	#include <GLUT/glut.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream>
#include <ostream>
#include <vector>
#include <string>


inline float deg2rad(float degree){return degree/360.0*2*M_PI;}



#define DIM3 3
#define DIM4 4
#define MATRIX_DIM 4

#include "vector4.h"
#include "vector3.h"
#include "matrix4.h"

//HW5 things
#include "shapes/shapes.h"
#include "node.h"
#include "group.h"
#include "leaf.h"
#include "transformgroup.h"
#include "shape3d.h"

#include "project5.h"
#include "robot.h"


struct Color    // generic color
{
  float r,g,b;
};

struct Point2D    // generic point in 2d
{
  int x,y;
  double z,w;
};

struct Vertex3D    // generic 3D vertex
{
  Color color;
  Vector3 coords;
};

struct Vertex2D    // generic 2D vertex, has a 2DPoint instead of Vector3
{
  Color color;
  Point2D coords;
};





#endif SS_Common_H
