#include "common.h"
#define STEP 5

using namespace std;

int Window::width  = 512;   // set window width in pixels here
int Window::height = 512;   // set window height in pixels here

//the base node
TransformGroup *rootNode;
//identity matrix
Matrix4 IDENTITY;

//----------------------------------------------------------------------------
// Callback method called when window is resized.
void Window::reshapeCallback(int w, int h)
{
  width = w;
  height = h;
  glViewport(0, 0, w, h);  // set new viewport size

}

//----------------------------------------------------------------------------
// Callback method called when special key is pressed.
void Window::specialFunc(int k, int x, int y)
{
	
  //  switch(k) {
//	      case GLUT_KEY_RIGHT: point_theta  -= STEP; break;
    //}
    
	glutPostRedisplay();
	
}

void Window::keyboardFunc(unsigned char key, int, int)
{
  cout << "Key pressed: " << key << endl;

	switch(key){
		case 'p':
			break;
			
		case 's':
			break;
		
	}
	glutPostRedisplay();
	
}


//----------------------------------------------------------------------------
// Callback method called when window readraw is necessary or
// when glutPostRedisplay() was called.
void Window::displayCallback(void)
{
	
	cout << "draw called!" << endl;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);  // clear color and depth buffers
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();


	  glMatrixMode(GL_PROJECTION);
	  glLoadIdentity();
	//  glFrustum(-10.0, 10.0, -10.0, 10.0, 10, 1000.0); // set perspective projection viewing frustum
	  gluPerspective(60.0, 1.0, 1.0, 100.0); 

  	//and camera
	  	glMatrixMode(GL_MODELVIEW); 
	//	glLoadIdentity(); 
		gluLookAt(	2.0, 2.0, 5.0, 
					0.0, 0.0, 0.0, 
					0.0, 1.0, 0.0);

	//set global color to white
  	glColor3f(1.0, 1.0, 1.0);
  	glShadeModel(GL_SMOOTH);
	//and draw away
	
	rootNode->draw(IDENTITY);
  

	//glutSolidSphere(1.2, 20, 20);

	glutSwapBuffers();
}


void Window::init(){
	// Initializes information for drawing within OpenGL.
	
      GLfloat sun_direction[] = { 0.0, 2.0, -1.0, 1.0 };
      GLfloat sun_intensity[] = { 0.7, 0.7, 0.7, 1.0 };
      GLfloat ambient_intensity[] = { 0.3, 0.3, 0.3, 1.0 };
	  glEnable(GL_DEPTH_TEST);            // Draw only closest surfaces

      glEnable(GL_LIGHTING);              // Set up ambient light.
      glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient_intensity);

      glEnable(GL_LIGHT0);                // Set up sunlight.
      glLightfv(GL_LIGHT0, GL_POSITION, sun_direction);
      glLightfv(GL_LIGHT0, GL_DIFFUSE, sun_intensity);

      glEnable(GL_COLOR_MATERIAL);        // Configure glColor().
      glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);


  
}

/* ---------------------------------------------------------
*
* ---------------------------------------------------------
*/

int main(int argc, char *argv[])
{
	
  
  glutInit(&argc, argv);      	      	      // initialize GLUT
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);   // open an OpenGL context with double buffering, RGB colors, and depth buffering
  glutInitWindowSize(Window::width, Window::height);      // set initial window size
  glutCreateWindow("Project5");    	                // open window and set window title

  glEnable(GL_DEPTH_TEST);            	      // enable depth buffering
  glClearColor(0.0, 0.0, 0.0, 0.0);   	      // set clear color to black
//  glMatrixMode(GL_PROJECTION); 
  
	
  Window::init();

	//pre-init the ident matrix
  IDENTITY.make_ident();
	//and make the robot
	rootNode = makeRobot();

	cout << "first childs tagName:" << (*rootNode->getChildren().begin())->tagName << endl;
	
  // Install callback functions:
  glutDisplayFunc(Window::displayCallback);
  glutReshapeFunc(Window::reshapeCallback);
  glutKeyboardFunc(Window::keyboardFunc);
  glutSpecialFunc(Window::specialFunc);
  glutMainLoop();
  return 0;
}

