//==================================================================
//==================================================================

#include "common.h"
using namespace std;

//==================================================================
// Makes a robot as a scenegraph
//==================================================================

//Matrix4 *ident;

//returns the root node of the robot
TransformGroup *makeRobot(){
	
	cout << "make robot called!" << endl;
	
//	ident = new Matrix4();
//	ident->make_ident();
	
	//doesnt need to have any transformation associated with it
	//since the torso is the center
	TransformGroup *root = new TransformGroup();
	root->setName("Root");
	
//	TransformGroup root;
	
	/* -----------------------
	* Torso
	* -----------------------
	*/
	//make box for torso
	Box *torso = new Box(1.4);
	//and Shape for it
	Shape3D *torseShape = new Shape3D(torso);
	torseShape->setName("TorsoShape");
	
	//and add
	root->addNode(torseShape);
	
	
	/* -----------------------
	* Head
	* -----------------------
	*/
	
	TransformGroup *headTransfo = new TransformGroup();
	headTransfo->M.make_translation(0,1.2,0);
	headTransfo->setName("HeadTransfo");
	
	//make sphere
	Sphere *headSphere = new Sphere(0.6);
	Shape3D *headShape = new Shape3D(headSphere);
	headShape->setName("head shape");
	//add sphere
	headTransfo->addNode(headShape);
	
	//and add to root
	root->addNode(headTransfo);


	//here we make the arm shape
	Node *ArmLeg = makeArm();
	ArmLeg->setName("ArmLeg");
	
	//left arm
	TransformGroup *lArmTransfo = new TransformGroup();
	lArmTransfo->setName("Left arm");
	//and move to upper border of box, and left side
	lArmTransfo->M.make_translation(-1,-0.5,0);
	lArmTransfo->addNode(ArmLeg);
	root->addNode(lArmTransfo);
	
	
	//right arm
	TransformGroup *rArmTransfo = new TransformGroup();
	rArmTransfo->setName("right arm");
	//and move to upper border of box, and left side
	rArmTransfo->M.make_translation(1,-0.5,0);
	rArmTransfo->addNode(ArmLeg);
	root->addNode(rArmTransfo);

	//left leg
	TransformGroup *lLegTransfo = new TransformGroup();
	lLegTransfo->setName("left leg");
	//and move to upper border of box, and left side
	lLegTransfo->M.make_translation(-0.5,-2,0);
	lLegTransfo->addNode(ArmLeg);
	root->addNode(lLegTransfo);

	//right leg
	TransformGroup *rLegTransfo = new TransformGroup();
	rLegTransfo->setName("right leg");
	//and move to upper border of box, and left side
	rLegTransfo->M.make_translation(0.5,-2,0);
	rLegTransfo->addNode(ArmLeg);
	root->addNode(rLegTransfo);
	
	
	return root;
}



TransformGroup *makeArm(){
	
	Matrix4 *temp = new Matrix4();
	/* -----------------------
	* Make arm/leg shape
	* -----------------------
	*/
	//first create the group for it, no transformation since its really just a group of things
	TransformGroup *group = new TransformGroup();
	
	//make the sphere at the center for the joint
	Sphere *center = new Sphere(0.2);
	Shape3D *centerShape = new Shape3D(center);
	//add
	group->addNode(centerShape);
	
	//make the sphere at upper joint
	TransformGroup *upperJ = new TransformGroup();
	upperJ->M.make_translation(0, 1, 0);
	Sphere *upperjoint = new Sphere(0.2);
	Shape3D *upperJShape = new Shape3D(upperjoint);
	//add
	upperJ->addNode(upperJShape);
	group->addNode(upperJ);
	
	//make upper part
	TransformGroup *upper = new TransformGroup();
	upper->M.make_translation(0, 0, 0);
	//and rotate around X-Axis 90 degrees, since Cylinder draws along z axis
	temp->make_rotX(-M_PI/2);
	upper->M *= (*temp);
	
	//h,r
	Cylinder *upperCyl = new Cylinder(1, 0.1);
	Shape3D *upperShape = new Shape3D(upperCyl);
	//add
	upper->addNode(upperShape);
	
	//add
	group->addNode(upper);

	//make lower
	TransformGroup *lower = new TransformGroup();
	lower->M.make_translation(0, 0, 0);
	//and rotate around X-Axis -90 degrees, since Cylinder draws along z axis
	temp->make_rotX(M_PI/2);
	lower->M *= *temp;
	
	//h,r
	Cylinder *lowerCyl = new Cylinder(1, 0.1);
	Shape3D *lowerShape = new Shape3D(lowerCyl);
	//add
	lower->addNode(lowerShape);
	
	//add
	group->addNode(lower);
	
	
	
	return group;
}


	