//==================================================================
//==================================================================

#include "common.h"
using namespace std;


	// ctor
	TransformGroup::TransformGroup() {
		
		cout << "ctor in TGroup called!" << endl;
		//M = new Matrix4(); 
		M.make_ident();
		cout << "ctor in TGroup returning, M=" << M << endl;
	}

//==================================================================
// TransformGroup Class Methods
//==================================================================

void TransformGroup::draw(Matrix4 C){
	int i;
	cout << "draw called for TGroup("<< M << ", w/ " << C << ")!" << endl;
	
	//make new Mat
	Matrix4 C_new = C * M;
	
	cout << "new_C="<< C_new << endl;
	
	cout << "iterating over #childs: "<< childNodes.size() << endl;
	
	//just call draw on all children
	for (i=0; i<childNodes.size(); i++){
		cout << "calling draw#"<< i << " on object: " << childNodes[i]->tagName << endl;
		childNodes[i]->draw(C_new);
	}
	/*
	for (vector<Node*>::iterator it = childNodes.begin(); it!=childNodes.end(); ++it) {
	    //print out name
		cout << "calling draw on object: " << (*it)->tagName << endl;
		(*it)->draw(C_new);
	}
	*/
}


//------------------------------------------------------------------
// Comparisons
//------------------------------------------------------------------

bool TransformGroup::operator==( TransformGroup o)
{
	int i;
	//check if matrixes match
	if ( M != o.M) return false;
	
	vector<Node*> oChilds = o.getChildren();
	
	
	//check length 
	if ( oChilds.size() != childNodes.size() ) return false;
	
	//and check each element
	for (i = 0; i < childNodes.size(); i++)
		if ( childNodes[i] != oChilds[i] ) return false;
	
	
	return true;
	
}

bool TransformGroup::operator!=( TransformGroup other)
{
	return !(*this == other);
}