//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Vector3_H
#define SS_Vector3_H


using namespace std;

//==================================================================
//  Vector3 Class Definition
//==================================================================

class Vector3 {
	
	protected:
		double v[3];      // z=0 for 2D, y=z=0 for 1D
	public:
	
public:
	//----------------------------------------------------------
	// Lots of ructors (add more as needed)
	Vector3() { 
		v[0]=v[1]=v[2]=0; 
	}
	
	// 3D Vector3
	Vector3( double a) {
		//cout << "Constructing Vec w/ " << a << endl;
		v[0]=a; v[1]=0; v[2]=0; 
	}
	// 3D Vector3
	Vector3( double a, double b) {
		v[0]=a; v[1]=b; v[2]=0; 
	}

	// 3D Vector3
	Vector3( double a, double b, double c) {
		v[0]=a; v[1]=b; v[2]=c; 
	}
	// Vector3 from Vec4, disregard 4th component
	Vector3( Vector4 a){
		v[0]=a[0]; v[1]=a[1]; v[2]=a[2]; 
	}

	// 3-dim Vector3
	Vector3( double a[3]){
		v[0]=a[0]; v[1]=a[1]; v[2]=a[2]; 
	}
	// Destructor
	~Vector3() {};
	//----------------------------------------------------------
	// get/set
	double 	get(int i){ return v[i]; }
	double&	operator[](const int);
	void 	set(int i, double d){ v[i] = d; }

	//----------------------------------------------------------
	// Comparison 
	bool operator==( Vector3 );
	bool operator!=( Vector3);


	//----------------------------------------------------------
	// Vector Arithmetic Operations
	 Vector3 operator+( Vector3&) ;
	 Vector3 operator-( Vector3&) ;
	 Vector3 operator/( double) ;
	 Vector3 operator*( double) ;
	
	//products
	double operator*( Vector3);        		// dot product
	Vector3 operator^( Vector3&) ;        // cross product

	//compund ops
	Vector3& operator*=( double);      // vector scalar mult
	Vector3& operator/=( double);      // vector scalar div
	Vector3& operator+=( Vector3);      // vector increment
	Vector3& operator-=( Vector3);      // vector decrement
	Vector3& operator^=( Vector3);      // cross product

	//----------------------------------------------------------
	// Vector Properties
	double len() {                    // vector length
		return sqrt((*this).len2());
	}
	double len2() {                   // vector length squared (faster)
		return (v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
	}

	//----------------------------------------------------------
	// Special Operations
	
	friend std::ostream &operator<<(std::ostream &out, Vector3 &vec);
	
	void normalize();                 // convert vector to unit length
};
#endif SS_Vector3_H