
//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Bezier_H
#define SS_Bezier_H


using namespace std;



//return parameter for bezier surface generator
struct SurfaceRev
{
	Vertex3D 	vertices[];		//the vertices, includes coords, normal and tex coords
	int 		indexArray[];	//index array of vertices
};

struct TrianglePtr
{
	Vertex3D 	*a,*b,*c;		//pointers to the three vertices forming this triangle
};


//calc a surface revolution
TrianglePtr *calcSurfaceRevolutionTria(int n, Vector3 CtrlPoints[], int n_points, double angle_delta);
TrianglePtr *calcSurfaceRevolutionTria(int n, Point2D CtrlPoints[], int n_points, double angle_delta);

Vertex3D *calcSurfaceRevolutionVx(int n, Vector3 CtrlPoints[], int n_points, double angle_delta);
Vertex3D *calcSurfaceRevolutionVx(int n, Point2D CtrlPoints[], int n_points, double angle_delta);

//bernstein calculat0r functions
Point2D *piecewiseBernsteinCalc(int n, Point2D CtrlPoints[], int n_points);
Point2D bernsteinCalculat0r(double t, Point2D ctrlPs[4]);
double b_x_t(int order, double t);

//Poly calculation functions
Quad2D *piecewisePolyCalc(int n, Point2D CtrlPoints[], int n_points);
Point2D *PolyCoeffs(Point2D p[4]);
Point2D PolyCalculat0r(double t, Point2D coeffs[4]);



#endif SS_Bezier_H