#include "common.h"
#define N_POINTS 50
#define ANGLE_DELTA 10


Point2D *makeCtrlPoints(){
	//make some control points
	Point2D *ctrl = (Point2D*)malloc(sizeof(Point2D)*7);
	
	//first segment starts at 0,0
	ctrl[0].x = 0; ctrl[0].y = 0;
	
	ctrl[1].x = 4; ctrl[1].y = 2;
	ctrl[2].x = 4; ctrl[2].y = 4;
	
	//line ends at 6,0
	ctrl[3].x = 0; ctrl[3].y = 6;

	//so second segment starts at 6,0
	//ctrl[4].x = 6; ctrl[4].y = 0;
	
	ctrl[4].x = 2; ctrl[4].y = 8;
	ctrl[5].x = 2; ctrl[5].y = 10;
	
	//line ends at 12,0
	ctrl[6].x = 0; ctrl[6].y = 12;
	return ctrl;
}


/*
struct TrianglePtr
{
	Vertex3D 	*a,*b,*c;		//pointers to the three vertices forming this triangle
};
*/

TrianglePtr *triangs = NULL;

void make_bezierSurface(){

		if (triangs != NULL) return;
	
		cout << "test_bezierSurface called!" << endl;
		
		Point2D *ctrl = makeCtrlPoints();
		

		cout << "calling calcSurfaceRevolutionTria()!" << endl;
		//segments, ctrl, points on line, angle
		triangs = calcSurfaceRevolutionTria(2, ctrl, N_POINTS, ANGLE_DELTA);
		//Point2D *vertices = piecewisePolyCalc(1, ctrl, N_POINTS);

}
void draw_bezierSurface(){
	

		//cout << "preparing to draw triangles!" << endl;
		int i;
		int n_triangs = ((360/ANGLE_DELTA) * (N_POINTS-1)) * 2;
		
		//now draw the triangs

		for (i = 0; i < (n_triangs); i++){
			glColor3f(1, 1, 1);
			glBegin(GL_TRIANGLES);
			//cout << "Drawing Triangle#" << i << endl;
			//cout << "Drawing Triangle at (" << triangs[i].a << "," << triangs[i].b << ", "<< triangs[i].c << ")" << endl;
			
			glColor3f((*triangs[i].a).color.r, (*triangs[i].a).color.g, (*triangs[i].a).color.b);
			glTexCoord2d((*triangs[i].a).u, (*triangs[i].a).v);
			glNormal3f((*triangs[i].a).normal[0], (*triangs[i].a).normal[1], (*triangs[i].a).normal[2]);
			glVertex3d((*triangs[i].a).coord[0], (*triangs[i].a).coord[1], (*triangs[i].a).coord[2]);
			
			glColor3f((*triangs[i].b).color.r, (*triangs[i].b).color.g, (*triangs[i].b).color.b);
			glTexCoord2d((*triangs[i].b).u, (*triangs[i].b).v);
			glNormal3f((*triangs[i].b).normal[0], (*triangs[i].b).normal[1], (*triangs[i].b).normal[2]);
			glVertex3d((*triangs[i].b).coord[0], (*triangs[i].b).coord[1], (*triangs[i].b).coord[2]);
			
			glColor3f((*triangs[i].c).color.r, (*triangs[i].c).color.g, (*triangs[i].c).color.b);
			glTexCoord2d((*triangs[i].c).u, (*triangs[i].c).v);
			glNormal3f((*triangs[i].c).normal[0], (*triangs[i].c).normal[1], (*triangs[i].c).normal[2]);
			glVertex3d((*triangs[i].c).coord[0], (*triangs[i].c).coord[1], (*triangs[i].c).coord[2]);
			glEnd();



			//now draw the vertices in green
			glBegin(GL_POINTS);
			glColor3f(0, 1, 0);
	
			glVertex3d((*triangs[i].a).coord[0], (*triangs[i].a).coord[1], (*triangs[i].a).coord[2]);
			glVertex3d((*triangs[i].b).coord[0], (*triangs[i].b).coord[1], (*triangs[i].b).coord[2]);
			glVertex3d((*triangs[i].c).coord[0], (*triangs[i].c).coord[1], (*triangs[i].c).coord[2]);
			
			glEnd();
		}

	
}