//==================================================================
// 
// 
// 
// 
//==================================================================

#ifndef SS_Vector4_H
#define SS_Vector4_H


//==================================================================
//  Vector4 Class Definition
//==================================================================

class Vector4 {
	
	protected:
		double v[4];      // z=0 for 2D, y=z=0 for 1D
	public:
	
public:
	//----------------------------------------------------------
	// Lots of Constructors (add more as needed)
	Vector4() { v[0]=v[1]=v[2]=v[3]=0; }

	// 3D Vector4
	Vector4( double a) {
		v[0]=a; v[1]=0; v[2]=0; v[3]=0;
	}

	// 3D Vector4
	Vector4( double a, double b) {
		v[0]=a; v[1]=b; v[2]=0; v[3]=0;
	}
	// 3D Vector4
	Vector4( double a, double b, double c) {
		v[0]=a; v[1]=b; v[2]=c; v[3]=0;
	}

	// 3D Vector4
	Vector4( double a, double b, double c, double d) {
		v[0]=a; v[1]=b; v[2]=c; v[3]=d;
	}
	// Array Vector4
	Vector4( double a[4]){
		v[0]=a[0]; v[1]=a[1]; v[2]=a[2]; v[3]=a[3]; 
	}

/*	
	//  Vector4 from other Vector4
	Vector4( Vector4& a){
		v[0]=a[0]; v[1]=a[1]; v[2]=a[2]; v[3]=a[3]; 
	}

	//  Vector4 from other Vector4
	Vector4( Vector4 a){
		v[0]=a[0]; v[1]=a[1]; v[2]=a[2]; v[3]=a[3]; 
	}
*/	

	
	// Destructor
	~Vector4() {};
	//----------------------------------------------------------
	// get/set
	double 	get(int i){ return v[i]; }
	double& operator[](const int);
	void 	set(int i, double d){ v[i] = d; }


	//----------------------------------------------------------
	// Comparison 
	bool operator==( Vector4 );
	bool operator!=( Vector4);


	//----------------------------------------------------------
	// Vector Arithmetic Operations
	Vector4 operator+( Vector4&);        // vector add
	Vector4 operator-( Vector4&);        // vector subtract
	Vector4 operator/(  double);        // 
	Vector4 operator*(  double);        // 

	//compund ops
	Vector4& operator*=( double);      // vector scalar mult
	Vector4& operator/=( double);      // vector scalar div
	Vector4& operator+=( Vector4);      // vector increment
	Vector4& operator-=( Vector4);      // vector decrement

	//----------------------------------------------------------
	// Vector Properties
	double len() {                    // vector length
		return sqrt((*this).len2());
	}
	double len2() {                   // vector length squared (faster)
		return (v[0]*v[0] + v[1]*v[1] + v[2]*v[2] + v[3]*v[3]);
	}


	//----------------------------------------------------------
	// Special Operations
	friend std::ostream &operator<<(std::ostream &out, Vector4 &vec);

	void normalize();                 // convert vector to unit length
	void dehomogenize();                 // make fourth component = 1
};
#endif SS_Vector4_H