#include "common.h"
#define N_POINTS 50
#define ANGLE_DELTA 10


Point2D *makeCtrlPoints(){
	//make some control points
	Point2D *ctrl = (Point2D*)malloc(sizeof(Point2D)*7);
	
	//first segment starts at 0,0
	ctrl[0].x = 0; ctrl[0].y = 0;
	
	ctrl[1].x = 6; ctrl[1].y = 2;
	ctrl[2].x = 6; ctrl[2].y = 4;
	
	//line ends at 6,0
	ctrl[3].x = 1; ctrl[3].y = 6;

	//so second segment starts at 6,0
	//ctrl[4].x = 6; ctrl[4].y = 0;
	
	ctrl[4].x = 2; ctrl[4].y = 8;
	ctrl[5].x = 2; ctrl[5].y = 10;
	
	//line ends at 12,0
	ctrl[6].x = 2; ctrl[6].y = 12;
	return ctrl;
}


void test_bezier1(){
	
	
	//test the piecewise bernstein calculat0r
	
	//make some control points
	Point2D *ctrl = makeCtrlPoints();

	//segments, ctrl, points on line
	//Point2D *vertices = piecewiseBernsteinCalc(2, ctrl, N_POINTS);
	//Point2D *vertices = piecewisePolyCalc(2, ctrl, N_POINTS);
	Quad2D *vertices = piecewisePolyCalc(2, ctrl, N_POINTS);
	
	
	int i;
	//now draw the vertices
	glBegin(GL_LINE_STRIP);
	
	for (i = 0; i < N_POINTS; i++){
		cout << "Drawing vertex at (" << vertices[i].p.x << "," << vertices[i].p.y << ")" << endl;
		glVertex3d(vertices[i].p.x, vertices[i].p.y, 0);
	}
	
	glEnd();
}

void test_bezier(){
	
	
	//test the piecewise bernstein calculat0r
	
	//make some control points
	Point2D ctrl[4];
	
	//first segment starts at 0,0
	ctrl[0].x = 0; ctrl[0].y = 0;
	
	ctrl[1].x = 3; ctrl[1].y = 2;
	ctrl[2].x = 3; ctrl[2].y = 4;
	
	//line ends at 6,0
	ctrl[3].x = 0; ctrl[3].y = 6;

	//segments, ctrl, points on line
	Point2D *vertices = piecewiseBernsteinCalc(1, ctrl, N_POINTS);
	//Point2D *vertices = piecewisePolyCalc(1, ctrl, N_POINTS);

	int i;
	//now draw the vertices
	//glBegin(GL_LINE_STRIP);
	glBegin(GL_POINTS);
	glColor3f(1, 1, 1);
	
	for (i = 0; i < N_POINTS; i++){
		cout << "Drawing vertex at (" << vertices[i].x << "," << vertices[i].y << ")" << endl;
		glVertex3d(vertices[i].x, vertices[i].y, 0);
	}
	
	glEnd();

	//now draw the control points
	//glBegin(GL_LINE_STRIP);
	glBegin(GL_POINTS);
	glColor3f(1, 0, 0);
	
	for (i = 0; i < 4; i++){
		cout << "Drawing control vertex at (" << ctrl[i].x << "," << ctrl[i].y << ")" << endl;
		glVertex3d(ctrl[i].x, ctrl[i].y, 0);
	}

	glEnd();
	glColor3f(1, 1, 1);
	
	
}



void test_bezierVertices(){
	
	
	//test the Bernstein bezier surface revolution	
	//make some control points
	Point2D ctrl[4];
	
	//first segment starts at 0,0
	ctrl[0].x = 0; ctrl[0].y = 0;
	
	ctrl[1].x = 4; ctrl[1].y = 2;
	ctrl[2].x = 4; ctrl[2].y = 4;
	
	//line ends at 6,0
	ctrl[3].x = 0; ctrl[3].y = 6;

//	Vertex3D *calcSurfaceRevolution(int n, Point2D CtrlPoints[], int n_points, double angle_delta)

	//segments, ctrl, points on line, angle
	Vertex3D *vertices = calcSurfaceRevolutionVx(1, ctrl, N_POINTS, ANGLE_DELTA);
	//Point2D *vertices = piecewisePolyCalc(1, ctrl, N_POINTS);
	
	
	int i,j;
	int angles = 360/ANGLE_DELTA, idx;

	//first draw lines in white
	glColor3f( 1, 1, 1);
	for (i = 0; i < angles; i++){
		glBegin(GL_LINE_STRIP);
		for (j = 0; j < N_POINTS; j++){
			idx = (j * angles) + i;
			//cout << "Drawing line from (" << vertices[i].coord[0] << "," << vertices[i].coord[1] << ", "<< vertices[i].coord[2]<< ")" << endl;
			glVertex3d(vertices[idx].coord[0], vertices[idx].coord[1], vertices[idx].coord[2]);
		}
		glEnd();
	}

	//now draw the vertices in green
	//glBegin(GL_LINE_STRIP);
	glBegin(GL_POINTS);
	glColor3f( 0, 1, 0);
	for (i = 0; i < (N_POINTS * (360/ANGLE_DELTA)); i++){
		cout << "Drawing vertex at (" << vertices[i].coord[0] << "," << vertices[i].coord[1] << ", "<< vertices[i].coord[2]<< ")" << endl;
		glVertex3d(vertices[i].coord[0], vertices[i].coord[1], vertices[i].coord[2]);
	}
	glEnd();

	
	//now draw the control points in red
	//glBegin(GL_LINE_STRIP);
	glBegin(GL_POINTS);
	glColor3f(1, 0, 0);
	
	for (i = 0; i < 4; i++){
		cout << "Drawing control vertex at (" << ctrl[i].x << "," << ctrl[i].y << ")" << endl;
		glVertex3d(ctrl[i].x, ctrl[i].y, 0);
	}

	glEnd();
	glColor3f(1, 1, 1);
	
	
}

/*
struct TrianglePtr
{
	Vertex3D 	*a,*b,*c;		//pointers to the three vertices forming this triangle
};
*/

TrianglePtr *triangs = NULL;

void make_bezierSurface(){

		if (triangs != NULL) return;
	
		cout << "test_bezierSurface called!" << endl;
		
		Point2D *ctrl = makeCtrlPoints();
		

		cout << "calling calcSurfaceRevolutionTria()!" << endl;
		//segments, ctrl, points on line, angle
		triangs = calcSurfaceRevolutionTria(2, ctrl, N_POINTS, ANGLE_DELTA);
		//Point2D *vertices = piecewisePolyCalc(1, ctrl, N_POINTS);

}
void draw_bezierSurface(){
	

		//cout << "preparing to draw triangles!" << endl;
		int i;
		int n_triangs = ((360/ANGLE_DELTA) * (N_POINTS-1)) * 2;
		
		//now draw the triangs

		for (i = 0; i < (n_triangs); i++){
			glColor3f(1, 1, 1);
			glBegin(GL_TRIANGLES);
			//cout << "Drawing Triangle#" << i << endl;
			//cout << "Drawing Triangle at (" << triangs[i].a << "," << triangs[i].b << ", "<< triangs[i].c << ")" << endl;
			
			glColor3f((*triangs[i].a).color.r, (*triangs[i].a).color.g, (*triangs[i].a).color.b);
			glTexCoord2d((*triangs[i].a).u, (*triangs[i].a).v);
			glNormal3f((*triangs[i].a).normal[0], (*triangs[i].a).normal[1], (*triangs[i].a).normal[2]);
			glVertex3d((*triangs[i].a).coord[0], (*triangs[i].a).coord[1], (*triangs[i].a).coord[2]);
			
			glColor3f((*triangs[i].b).color.r, (*triangs[i].b).color.g, (*triangs[i].b).color.b);
			glTexCoord2d((*triangs[i].b).u, (*triangs[i].b).v);
			glNormal3f((*triangs[i].b).normal[0], (*triangs[i].b).normal[1], (*triangs[i].b).normal[2]);
			glVertex3d((*triangs[i].b).coord[0], (*triangs[i].b).coord[1], (*triangs[i].b).coord[2]);
			
			glColor3f((*triangs[i].c).color.r, (*triangs[i].c).color.g, (*triangs[i].c).color.b);
			glTexCoord2d((*triangs[i].c).u, (*triangs[i].c).v);
			glNormal3f((*triangs[i].c).normal[0], (*triangs[i].c).normal[1], (*triangs[i].c).normal[2]);
			glVertex3d((*triangs[i].c).coord[0], (*triangs[i].c).coord[1], (*triangs[i].c).coord[2]);
			glEnd();



			//now draw the vertices in green
			glBegin(GL_POINTS);
			glColor3f(0, 1, 0);
	
			glVertex3d((*triangs[i].a).coord[0], (*triangs[i].a).coord[1], (*triangs[i].a).coord[2]);
			glVertex3d((*triangs[i].b).coord[0], (*triangs[i].b).coord[1], (*triangs[i].b).coord[2]);
			glVertex3d((*triangs[i].c).coord[0], (*triangs[i].c).coord[1], (*triangs[i].c).coord[2]);
			
			glEnd();
		}

	
}