//==================================================================
//==================================================================

#include "../common.h"
using namespace std;

//==================================================================
// Mat Class Methods
//==================================================================


//------------------------------------------------------------------
// set stuff
//------------------------------------------------------------------


void Material::setAmbient(float r=0.2, float g=0.2, float b=0.2, float a=1){

	GLfloat light_ambient[] = { r, g, b, a};
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, light_ambient);	
	
}


void Material::setDiffuse(float r=0.8, float g=0.8, float b=0.8, float a=1){
	
	GLfloat light_diff[] = { r, g, b, a};
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, light_diff);	

}

void Material::setSpecular(float r=0, float g=0, float b=0, float a=1, float shin=0){
	
	GLfloat light_diff[] = { r, g, b, a};
	GLfloat shininess[] = { shin };
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, light_diff);	
	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, shininess);	

}

void Material::setEmissive(float r=0, float g=0, float b=0, float a=1){
	
	GLfloat light_diff[] = { r, g, b, a};
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, light_diff);	

}
