//------------------------------------------------------------------
//------------------------------------------------------------------

#ifndef SS_Common_H
#define SS_Common_H

#ifdef _WIN32
  	#include <windows.h>
	#include <GL/glut.h>
	#include <GL/gl.h>
#else
	#include <GLUT/glut.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream>
#include <ostream>
#include <vector>
#include <string>

#include "base/base.h"


inline float deg2rad(float degree){return degree/360.0*2*M_PI;}


struct Color    // generic color
{
  	float r,g,b,a;
};

struct Point2D    // generic point in 2d
{
  	double x,y;
};

struct Quad2D    // generic point in 2d with derivative
{
  	Point2D p;	//the point
	Point2D d;	//the derivative
};

struct Vertex3D    // generic 3D vertex
{
  	Color color;
  	Vector3 coord;
  	Vector3 normal;
	double u,v;		//texture coords
};

struct Vertex2D    // generic 2D vertex, has a 2DPoint instead of Vector3
{
  	Color color;
  	Point2D coord;
};

#include "bezier.h"
#include "project6.h"


#endif SS_Common_H
